﻿package  {

	import flash.display.*;
	import flash.events.Event;
	import flash.text.engine.*;

	public class Test3DTextBox extends MovieClip {

		private var _msg:String;
		private var _lines:Array;

		public function Test3DTextBox( msg:String ) {

			_msg = msg;
			_lines = [];
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);

		}

		private function init(e:Event = null):void {

			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// 設定値
			var txtColor:uint = 0x00, fontSize:uint = 14, BOX_HEIGHT:uint = fontSize * 10;
			
			// フォント情報
			var font:FontDescription = new FontDescription( "AXIS Std B", FontWeight.NORMAL, FontPosture.NORMAL, FontLookup.DEVICE, RenderingMode.CFF );
			// 整列フォーマット情報
			var format:ElementFormat = new ElementFormat( font, fontSize, txtColor );
			format.locale = "ja";

			// 段組
			var textBlock :TextBlock = new TextBlock();
			// 字の整列方向（縦書き）
			textBlock.lineRotation = TextRotation.ROTATE_90;
			textBlock.textJustifier = new EastAsianJustifier("ja", LineJustification.UNJUSTIFIED );

			// 文字情報設定
			textBlock.content = new TextElement( _msg, format );

			// 実際に整形と配置
			var i:uint = 0;
			var textLine:TextLine = textBlock.createTextLine( null, BOX_HEIGHT );
			while (textLine) {
				_lines.push( textLine );
				addChild( textLine );
				textLine.x = 400 - 16 * i++;
				textLine.y = 200;
				textLine.z = Math.random() * 1000 - 500;
				textLine.rotationX = Math.random() * 360;
				textLine.rotationY = Math.random() * 360;
				textLine.rotationZ = Math.random() * 360;
				textLine = textBlock.createTextLine(textLine, BOX_HEIGHT );
			}
		
			addEventListener(Event.ENTER_FRAME, rot );
			
		}
		
		private function rot(e:Event):void {
			
			for each( var textLine:TextLine in _lines ) {
				textLine.rotationX += 4; 
				textLine.rotationY += 3; 
				textLine.rotationZ += 6; 
			}
			
		}

	}

}