﻿package  {

	import flash.display.*;
	import flash.events.Event;
	import flash.text.engine.*;

	public class TestTextBox extends MovieClip {

		private var _msg:String;

		public function TestTextBox( msg:String ) {

			_msg = msg;
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);

		}

		private function init(e:Event = null):void {

			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			// 設定値
			var txtColor:uint = 0x000033, fontSize:uint = 24, BOX_HEIGHT:uint = fontSize * 10;
			
			// フォント情報
			var font:FontDescription = new FontDescription( "AXIS Std B", FontWeight.NORMAL, FontPosture.NORMAL, FontLookup.DEVICE, RenderingMode.CFF );
			// 整列フォーマット情報
			var format:ElementFormat = new ElementFormat( font, fontSize, txtColor );
			format.locale = "ja";

			// 段組
			var textBlock :TextBlock = new TextBlock();
			// 字の整列方向（縦書き）
			textBlock.lineRotation = TextRotation.ROTATE_90;
			textBlock.textJustifier = new EastAsianJustifier("ja", LineJustification.UNJUSTIFIED );

			// 文字情報設定
			textBlock.content = new TextElement( _msg, format );

			// 実際に整形と配置
			var i:uint = 0;
			var textLine:TextLine = textBlock.createTextLine( null, BOX_HEIGHT );
			while (textLine) {
				addChild( textLine );
				textLine.x = 480 - 28 * i++;
				textLine.y = 10;
				textLine = textBlock.createTextLine(textLine, BOX_HEIGHT );
			}

			// 整列フォーマットを複製して色をかえる
			format = format.clone();
			format.color = 0x006633;
			// 新しい文章を設定して追加配置する
			textBlock.content = new TextElement( _msg, format );
			textLine = textBlock.createTextLine( null, BOX_HEIGHT );
			while (textLine) {
				addChild( textLine );
				textLine.x = 480 - 28 * i++;
				textLine.y = 10;
				textLine = textBlock.createTextLine(textLine, BOX_HEIGHT );
			}
		
		}

	}

}